var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import React, { useEffect, useState, useCallback, useRef, useContext, useImperativeHandle, forwardRef, } from 'react';
import Draggable from 'react-draggable';
import { Dialog, NoticeBar, Toast } from 'antd-mobile';
import { NECall, } from '@xkit-yx/call-kit';
import { EventTracking } from '@xkit-yx/utils';
import pkg from '../../../package.json';
import { secondToDate } from '../../utils';
import avatarDefaultMan from '../../assets/avatar-default-man.png';
import videoOpen from '../../assets/video-open.png';
import videoClose from '../../assets/video-close.png';
import microphoneOpen from '../../assets/microphone-open.png';
import microphoneClose from '../../assets/microphone-close.png';
import hangup from '../../assets/hangup.png';
import videoAccept from '../../assets/video-accept.png';
import audioAccept from '../../assets/audio-accept.png';
import switchVideo from '../../assets/switch-video.png';
import switchAudio from '../../assets/switch-audio.png';
var CallContext = React.createContext({});
var useCall = function () {
    return useContext(CallContext);
};
var CallProvider = CallContext.Provider;
export { CallProvider, useCall };
var InviteView = function (_a) {
    var onHangup = _a.onHangup, calleeInfo = _a.calleeInfo, callType = _a.callType;
    var prefixCls = 'necall';
    var neCall = useCall().neCall;
    var previewRef = useRef(null);
    useEffect(function () {
        if (previewRef.current && neCall && callType === '2') {
            neCall.initAndPlayLocalSteam(previewRef.current);
        }
    }, [neCall, callType]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: "".concat(prefixCls, "-blur-bg-mark"), ref: previewRef },
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-blur-bg-img"), src: (calleeInfo === null || calleeInfo === void 0 ? void 0 : calleeInfo.avatar) || avatarDefaultMan, alt: "" })),
        React.createElement("div", { className: "".concat(prefixCls, "-callee-info") },
            React.createElement("div", null,
                React.createElement("div", { className: "".concat(prefixCls, "-callee-nickname") },
                    "\u6B63\u5728\u547C\u53EB ",
                    (calleeInfo === null || calleeInfo === void 0 ? void 0 : calleeInfo.nick) || (calleeInfo === null || calleeInfo === void 0 ? void 0 : calleeInfo.tel)),
                React.createElement("div", { className: "".concat(prefixCls, "-callee-tips") }, "\u7B49\u5F85\u5BF9\u65B9\u63A5\u542C...")),
            React.createElement("img", { className: "".concat(prefixCls, "-callee-avatar"), src: (calleeInfo === null || calleeInfo === void 0 ? void 0 : calleeInfo.avatar) || avatarDefaultMan, alt: "" })),
        React.createElement("div", { className: "".concat(prefixCls, "-calling-btn-group") },
            React.createElement("div", { className: "".concat(prefixCls, "-btn"), onClick: function () { return onHangup(); } },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-img"), src: hangup }),
                React.createElement("span", null, "\u53D6\u6D88")))));
};
var BeInvitedView = function (_a) {
    var onAccept = _a.onAccept, onHangup = _a.onHangup, callerInfo = _a.callerInfo, callType = _a.callType;
    var prefixCls = 'necall';
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: "".concat(prefixCls, "-blur-bg-mark") },
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-blur-bg-img"), src: (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.avatar) || avatarDefaultMan, alt: "" })),
        React.createElement("div", { className: "".concat(prefixCls, "-caller-info") },
            React.createElement("img", { className: "".concat(prefixCls, "-caller-avatar"), src: (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.avatar) || avatarDefaultMan, alt: "" }),
            React.createElement("div", { className: "".concat(prefixCls, "-caller-nickname") }, (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.nick) || (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.tel)),
            React.createElement("div", { className: "".concat(prefixCls, "-caller-tips") }, callType === '1' ? '邀请你进行语音通话...' : '邀请你进行视频通话...')),
        React.createElement("div", { className: "".concat(prefixCls, "-called-btn-group") },
            React.createElement("div", { className: "".concat(prefixCls, "-btn") },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-img"), src: hangup, onClick: function () { return onHangup(); } }),
                React.createElement("span", null, "\u62D2\u7EDD")),
            React.createElement("div", { className: "".concat(prefixCls, "-btn") },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-img"), src: callType === '1' ? audioAccept : videoAccept, onClick: function () { return onAccept(); } }),
                React.createElement("span", null, "\u63A5\u542C")))));
};
var InCallView = function (props) {
    var _a, _b;
    var onHangup = props.onHangup, remoteUserInfo = props.remoteUserInfo, switchCallTypeBtn = props.switchCallTypeBtn;
    var prefixCls = 'necall';
    var avatar = (remoteUserInfo === null || remoteUserInfo === void 0 ? void 0 : remoteUserInfo.avatar) || avatarDefaultMan;
    var neCall = useCall().neCall;
    var _c = __read(useState(props.callType), 2), callType = _c[0], setCallType = _c[1];
    var _d = __read(useState(true), 2), enableLocalAudio = _d[0], setEnableLocalAudio = _d[1];
    var _e = __read(useState(true), 2), enableLocalVideo = _e[0], setEnableLocalVideo = _e[1];
    var _f = __read(useState(''), 2), noticeText = _f[0], setNoticeText = _f[1];
    var _g = __read(useState(0), 2), duration = _g[0], setDuration = _g[1];
    var domRef = useRef(null);
    var dialogVisibilityRef = useRef(false);
    useEffect(function () {
        var timer = setTimeout(function () {
            setDuration(duration + 1);
        }, 1000);
        return function () {
            clearTimeout(timer);
        };
    }, [duration]);
    useEffect(function () {
        var handleCallTypeChange = function (value) {
            var callType = value.callType;
            if (value.state === 1) {
                if (dialogVisibilityRef.current)
                    return;
                dialogVisibilityRef.current = true;
                var content = callType === '1'
                    ? '对方请求将视频转为音频，将直接关闭您的摄像头'
                    : '对方请求将转音频为视频，需要打开您的摄像头';
                Dialog.confirm({
                    title: '权限请求',
                    content: content,
                    cancelText: '拒绝',
                    confirmText: '同意',
                    onConfirm: function () {
                        dialogVisibilityRef.current = false;
                        neCall === null || neCall === void 0 ? void 0 : neCall.switchCallType({ callType: callType, state: 2 });
                    },
                    onCancel: function () {
                        dialogVisibilityRef.current = false;
                        neCall === null || neCall === void 0 ? void 0 : neCall.switchCallType({ callType: callType, state: 3 });
                    },
                    getContainer: domRef.current,
                });
            }
            if (value.state === 2) {
                setNoticeText('');
                setCallType(value.callType);
                setEnableLocalAudio(true);
                setEnableLocalVideo(true);
                if (neCall === null || neCall === void 0 ? void 0 : neCall.rtcController.localStream) {
                    var hasVideo = neCall.rtcController.localStream.hasVideo();
                    var enableVideo_1 = callType === '2';
                    if (enableVideo_1 !== hasVideo) {
                        if (enableVideo_1) {
                            neCall.enableLocalVideo(enableVideo_1).then(function () {
                                neCall.muteLocalVideo(!enableVideo_1);
                            });
                        }
                        else {
                            neCall.muteLocalVideo(!enableVideo_1).then(function () {
                                neCall.enableLocalVideo(enableVideo_1);
                            });
                        }
                    }
                    neCall.muteLocalAudio(false);
                }
            }
            if (value.state === 3) {
                setNoticeText('');
                Toast.show({
                    content: '对方拒绝了您的请求',
                    duration: 3000,
                    getContainer: domRef.current,
                });
            }
        };
        neCall === null || neCall === void 0 ? void 0 : neCall.on('onCallTypeChange', handleCallTypeChange);
        return function () {
            neCall === null || neCall === void 0 ? void 0 : neCall.off('onCallTypeChange', handleCallTypeChange);
        };
    }, [neCall]);
    var switchCallType = useCallback(function (state) { return __awaiter(void 0, void 0, void 0, function () {
        var data, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!neCall) return [3 /*break*/, 4];
                    data = callType === '1' ? '2' : '1';
                    setNoticeText('正在等待对方响应...');
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, neCall.switchCallType({ callType: data, state: state })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    setNoticeText('');
                    throw err_1;
                case 4: return [2 /*return*/];
            }
        });
    }); }, [neCall, callType]);
    var handleEnableLocalVideo = useCallback(function () {
        if (neCall) {
            var enableVideo_2 = !enableLocalVideo;
            if (enableVideo_2) {
                neCall.enableLocalVideo(enableVideo_2).then(function () {
                    neCall.muteLocalVideo(!enableVideo_2);
                });
            }
            else {
                neCall.muteLocalVideo(!enableVideo_2).then(function () {
                    neCall.enableLocalVideo(enableVideo_2);
                });
            }
            setEnableLocalVideo(!enableLocalVideo);
        }
    }, [neCall, enableLocalVideo]);
    var handleEnableLocalAudio = useCallback(function () {
        if (neCall) {
            neCall.muteLocalAudio(enableLocalAudio);
            setEnableLocalAudio(!enableLocalAudio);
        }
    }, [neCall, enableLocalAudio]);
    return (React.createElement("div", { ref: domRef },
        noticeText && (React.createElement(NoticeBar, { className: "".concat(prefixCls, "-notice"), content: noticeText, color: "alert", onClose: function () { return setNoticeText(''); }, icon: null, closeable: true })),
        callType === '1' ? (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "".concat(prefixCls, "-blur-bg-mark") },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-blur-bg-img"), src: avatar, alt: "" })),
            React.createElement("div", { className: "".concat(prefixCls, "-in-call-audio") },
                React.createElement("img", { className: "".concat(prefixCls, "-in-call-avatar"), src: avatar, alt: "" }),
                React.createElement("div", { className: "".concat(prefixCls, "-in-call-title") }, "\u901A\u8BDD\u4E2D"),
                React.createElement("div", { className: "".concat(prefixCls, "-in-call-tips") }, secondToDate(duration))))) : (React.createElement("div", { className: "".concat(prefixCls, "-in-call-duration") }, secondToDate(duration))),
        React.createElement("div", { className: "".concat(prefixCls, "-in-call-btn-group") },
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-microphone-btn"), src: enableLocalAudio ? microphoneOpen : microphoneClose, onClick: function () { return handleEnableLocalAudio(); } }),
            callType === '2' && (React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-video-btn"), src: enableLocalVideo ? videoOpen : videoClose, onClick: function () { return handleEnableLocalVideo(); } })),
            callType === '1' && ((_a = switchCallTypeBtn === null || switchCallTypeBtn === void 0 ? void 0 : switchCallTypeBtn.switchToVideo) !== null && _a !== void 0 ? _a : false) && (React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-switch-btn"), src: switchVideo, onClick: function () { return switchCallType(1); } })),
            callType === '2' && ((_b = switchCallTypeBtn === null || switchCallTypeBtn === void 0 ? void 0 : switchCallTypeBtn.switchToAudio) !== null && _b !== void 0 ? _b : true) && (React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-switch-btn"), src: switchAudio, onClick: function () { return switchCallType(1); } })),
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-hangup-btn"), onClick: function () { return onHangup(); }, src: hangup }))));
};
var CallViewProvider = forwardRef(function (props, ref) {
    var prefixCls = 'necall';
    var neCallConfig = props.neCallConfig, _a = props.position, position = _a === void 0 ? { x: 100, y: 100 } : _a, uiConfig = props.uiConfig;
    var draggableNodeRef = useRef(null);
    var smallViewRef = useRef(null);
    var largeViewRef = useRef(null);
    var localViewRef = useRef();
    var _b = __read(useState(), 2), neCall = _b[0], setNeCall = _b[1];
    var _c = __read(useState(0), 2), callStatus = _c[0], setCallStatus = _c[1]; // 0:闲置 1:正在呼叫 2:正在被呼叫 3: 连接建立中 4:通话中
    var _d = __read(useState('1'), 2), callType = _d[0], setCallType = _d[1]; // 1 音频 2 视频
    var _e = __read(useState(), 2), remoteUserInfo = _e[0], setRemoteUserInfo = _e[1];
    useEffect(function () {
        if (neCallConfig) {
            var neCall_1 = NECall.getInstance();
            // @ts-ignore
            window.__necall__ = neCall_1;
            neCall_1.setup(neCallConfig);
            setNeCall(neCall_1);
            setCallStatus(0);
            // 接入统计
            var eventTracking = new EventTracking({
                appKey: neCallConfig.appkey,
                version: pkg.version,
                component: 'CallKitReactUI',
            });
            eventTracking.track('init', '');
            return function () {
                neCall_1.destroy();
            };
        }
        // 这里需要在第一次挂载时才执行
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    useEffect(function () {
        var remoteAccount = remoteUserInfo === null || remoteUserInfo === void 0 ? void 0 : remoteUserInfo.account;
        if (smallViewRef.current && largeViewRef.current && remoteAccount) {
            neCall === null || neCall === void 0 ? void 0 : neCall.setLocalView(smallViewRef.current);
            neCall === null || neCall === void 0 ? void 0 : neCall.setRemoteView(largeViewRef.current);
            localViewRef.current = smallViewRef.current;
            var handleCallTypeChange_1 = function (value) {
                if (value.state === 2 && smallViewRef.current && largeViewRef.current) {
                    neCall === null || neCall === void 0 ? void 0 : neCall.setLocalView(smallViewRef.current);
                    neCall === null || neCall === void 0 ? void 0 : neCall.setRemoteView(largeViewRef.current);
                }
            };
            neCall === null || neCall === void 0 ? void 0 : neCall.on('onCallTypeChange', handleCallTypeChange_1);
            return function () {
                neCall === null || neCall === void 0 ? void 0 : neCall.off('onCallTypeChange', handleCallTypeChange_1);
            };
        }
    }, [neCall, remoteUserInfo]);
    useEffect(function () {
        if (neCall) {
            var handleReceiveInvited_1 = function (value) {
                setCallType(value.callType);
                setCallStatus(2);
                neCallConfig.nim.V2NIMUserService.getUserList([value.callerAccId])
                    .then(function (data) {
                    var user = data[0];
                    if (user) {
                        setRemoteUserInfo({
                            account: user.accountId,
                            avatar: user.avatar || '',
                            nick: user.name,
                            tel: user.mobile || '',
                        });
                    }
                })
                    .catch(function (err) {
                    var error = err;
                    console.error('获取对端用户信息失败', value.callerAccId, error.toString());
                });
            };
            var handleCallConnected_1 = function () {
                setCallStatus(3);
            };
            var handleCallEnd_1 = function () {
                setCallStatus(0);
            };
            neCall.on('onReceiveInvited', handleReceiveInvited_1);
            neCall.on('onCallConnected', handleCallConnected_1);
            neCall.on('onCallEnd', handleCallEnd_1);
            return function () {
                neCall.off('onReceiveInvited', handleReceiveInvited_1);
                neCall.off('onCallConnected', handleCallConnected_1);
                neCall.off('onCallEnd', handleCallEnd_1);
            };
        }
    }, [neCall, neCallConfig]);
    var handleCall = useCallback(function (opt) { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!neCall) return [3 /*break*/, 2];
                    return [4 /*yield*/, neCall.call(opt)];
                case 1:
                    res = _a.sent();
                    setCallType(opt.callType);
                    setCallStatus(1);
                    neCallConfig.nim.V2NIMUserService.getUserList([opt.accId])
                        .then(function (data) {
                        var user = data[0];
                        if (user) {
                            setRemoteUserInfo({
                                account: user.accountId,
                                avatar: user.avatar || '',
                                nick: user.name,
                                tel: user.mobile || '',
                            });
                        }
                    })
                        .catch(function (err) {
                        var error = err;
                        console.error('获取对端用户信息失败', opt.accId, error.toString());
                    });
                    return [2 /*return*/, res];
                case 2: return [2 /*return*/];
            }
        });
    }); }, [neCall, neCallConfig]);
    var handleAccept = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (neCall === null || neCall === void 0 ? void 0 : neCall.accept())];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [neCall]);
    var handleHangup = useCallback(function () {
        setCallStatus(0);
        setRemoteUserInfo(undefined);
        neCall === null || neCall === void 0 ? void 0 : neCall.hangup();
    }, [neCall]);
    var switchPlayView = useCallback(function () {
        var remoteAccount = remoteUserInfo === null || remoteUserInfo === void 0 ? void 0 : remoteUserInfo.account;
        if (smallViewRef.current &&
            largeViewRef.current &&
            remoteAccount &&
            neCall) {
            if (localViewRef.current === smallViewRef.current) {
                neCall.setLocalView(largeViewRef.current);
                neCall.setRemoteView(smallViewRef.current);
                localViewRef.current = largeViewRef.current;
            }
            else {
                neCall.setLocalView(smallViewRef.current);
                neCall.setRemoteView(largeViewRef.current);
                localViewRef.current = smallViewRef.current;
            }
            var rtcUid_1 = neCall.getUidByAccId(remoteAccount);
            var remoteStream = neCall.rtcController.remoteStreams.find(function (item) { return item.getId() === rtcUid_1; });
            neCall.rtcController.playLocalStream();
            remoteStream && neCall.rtcController.playRemoteStream(remoteStream);
        }
    }, [neCall, remoteUserInfo]);
    useImperativeHandle(ref, function () { return ({
        call: handleCall,
        neCall: neCall,
    }); }, [neCall, handleCall]);
    return (React.createElement(CallProvider, { value: { call: handleCall, neCall: neCall } },
        callStatus !== 0 && (React.createElement(Draggable, { nodeRef: draggableNodeRef, cancel: ".".concat(prefixCls, "-calling-btn-group .").concat(prefixCls, "-img, .").concat(prefixCls, "-called-btn-group .").concat(prefixCls, "-img, .").concat(prefixCls, "-in-call-btn-group, .").concat(prefixCls, "-small-view") },
            React.createElement("div", { style: { top: position.y, left: position.x }, className: "".concat(prefixCls, "-view"), ref: draggableNodeRef },
                React.createElement("div", { className: "".concat(prefixCls, "-large-view"), ref: largeViewRef }),
                React.createElement("div", { className: "".concat(prefixCls, "-small-view"), ref: smallViewRef, onClick: function () { return switchPlayView(); } }),
                callStatus === 1 && (React.createElement(InviteView, { calleeInfo: remoteUserInfo, callType: callType, onHangup: handleHangup })),
                callStatus === 2 && (React.createElement(BeInvitedView, { callerInfo: remoteUserInfo, callType: callType, onAccept: handleAccept, onHangup: handleHangup })),
                callStatus === 3 && (React.createElement(InCallView, { remoteUserInfo: remoteUserInfo, switchCallTypeBtn: uiConfig === null || uiConfig === void 0 ? void 0 : uiConfig.switchCallTypeBtn, callType: callType, onHangup: handleHangup }))))),
        props.children));
});
export default CallViewProvider;
