var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import React, { useEffect, useMemo, useState, useCallback, useRef, forwardRef, useContext, useImperativeHandle, } from 'react';
import Draggable from 'react-draggable';
import { NEGroupCall, } from '@xkit-yx/call-kit';
import { Swiper, SwiperSlide } from 'swiper/react';
import { AddOutline } from 'antd-mobile-icons';
import { secondToDate } from '../../utils';
import avatarDefaultMan from '../../assets/avatar-default-man.png';
import videoOpen from '../../assets/video-open.png';
import videoClose from '../../assets/video-close.png';
import microphoneOpen from '../../assets/microphone-open.png';
import microphoneClose from '../../assets/microphone-close.png';
import hangup from '../../assets/hangup.png';
import audioAccept from '../../assets/audio-accept.png';
var GroupCallContext = React.createContext({});
var useGroupCall = function () {
    return useContext(GroupCallContext);
};
var GroupCallProvider = GroupCallContext.Provider;
export { GroupCallProvider, useGroupCall };
var Loading = function () {
    return (React.createElement("div", { className: "lds-ellipsis" },
        React.createElement("div", null),
        React.createElement("div", null),
        React.createElement("div", null),
        React.createElement("div", null)));
};
var InvitedView = function (_a) {
    var callerAccid = _a.callerAccid, currentAccid = _a.currentAccid, members = _a.members, onAccept = _a.onAccept, onReject = _a.onReject;
    var prefixCls = 'necall-group';
    var callerInfo = members === null || members === void 0 ? void 0 : members.find(function (item) { return item.account === callerAccid; });
    var otherMembers = members === null || members === void 0 ? void 0 : members.filter(function (item) { return ![currentAccid, callerAccid].includes(item.account); });
    return (React.createElement("div", { className: "".concat(prefixCls, "-invited-view-container") },
        React.createElement("div", { className: "".concat(prefixCls, "-caller-info") },
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-caller-avatar"), src: (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.avatar) || avatarDefaultMan, alt: "" }),
            React.createElement("div", { className: "".concat(prefixCls, "-caller-nickname") }, (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.nick) || (callerInfo === null || callerInfo === void 0 ? void 0 : callerInfo.tel)),
            React.createElement("div", { className: "".concat(prefixCls, "-caller-tips") }, "\u9080\u8BF7\u60A8\u52A0\u5165\u591A\u4EBA\u901A\u8BDD"),
            otherMembers && otherMembers.length > 0 && (React.createElement(React.Fragment, null,
                React.createElement("div", { className: "".concat(prefixCls, "-member-tips") },
                    "\u8FD8\u6709",
                    otherMembers.length,
                    "\u4EBA\u53C2\u4E0E\u901A\u8BDD"),
                React.createElement("div", { className: "".concat(prefixCls, "-member-list") }, otherMembers.map(function (member) { return (React.createElement("img", { draggable: "false", key: member.account, className: "".concat(prefixCls, "-member-item"), src: member.avatar || avatarDefaultMan })); }))))),
        React.createElement("div", { className: "".concat(prefixCls, "-called-btn-group") },
            React.createElement("div", { className: "".concat(prefixCls, "-btn") },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-img"), src: hangup, onClick: function () { return onReject(); } }),
                React.createElement("span", null, "\u62D2\u7EDD")),
            React.createElement("div", { className: "".concat(prefixCls, "-btn") },
                React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-img"), src: audioAccept, onClick: function () { return onAccept(); } }),
                React.createElement("span", null, "\u63A5\u542C")))));
};
var InCallView = function (_a) {
    var members = _a.members, neGroupCall = _a.neGroupCall, onHangup = _a.onHangup;
    var prefixCls = 'necall-group';
    var _b = __read(useState(true), 2), enableLocalAudio = _b[0], setEnableLocalAudio = _b[1];
    var _c = __read(useState(false), 2), enableLocalVideo = _c[0], setEnableLocalVideo = _c[1];
    var _d = __read(useState(0), 2), duration = _d[0], setDuration = _d[1];
    var domsRef = useRef({});
    useEffect(function () {
        var timer = setTimeout(function () {
            setDuration(duration + 1);
        }, 1000);
        return function () {
            clearTimeout(timer);
        };
    }, [duration]);
    useEffect(function () {
        members.forEach(function (member) {
            var accId = member.account;
            neGroupCall.setRtcView(domsRef.current[accId], accId);
        });
    }, [members, neGroupCall]);
    useEffect(function () {
        // 延迟加入，避免自动占线挂断
        var timer = setTimeout(function () {
            neGroupCall.joinRtc({ video: false });
        }, 500);
        return function () {
            clearTimeout(timer);
        };
    }, [neGroupCall]);
    var membersGroup = useMemo(function () {
        var _members = members.filter(function (member) { return member.state !== 3; });
        var result = [];
        for (var i = 0, len = _members.length; i < len; i += 4) {
            result.push({
                id: result.length,
                members: _members.slice(i, i + 4),
            });
        }
        return result;
    }, [members]);
    var handleEnableLocalAudio = function () {
        setEnableLocalAudio(!enableLocalAudio);
        neGroupCall.enableLocalAudio(!enableLocalAudio);
    };
    var handleEnableLocalVideo = function () {
        setEnableLocalVideo(!enableLocalVideo);
        neGroupCall.enableLocalVideo(!enableLocalVideo);
    };
    var handleHangup = function () {
        onHangup();
    };
    return (React.createElement("div", { className: "".concat(prefixCls, "-incall-view-container") },
        React.createElement("div", { className: "".concat(prefixCls, "-incall-scroll-view") },
            React.createElement("div", { className: "".concat(prefixCls, "-incall-duration") }, secondToDate(duration)),
            React.createElement(Swiper, { slidesPerView: 1 }, membersGroup.map(function (item) {
                return (React.createElement(SwiperSlide, { className: "".concat(prefixCls, "-incall-rtc-page"), key: item.id }, item.members.map(function (member) { return (React.createElement("div", { key: member.account, className: "".concat(prefixCls, "-incall-rtc-view"), ref: function (el) { return el && (domsRef.current[member.account] = el); } },
                    React.createElement("div", { className: "".concat(prefixCls, "-incall-rtc-user") },
                        React.createElement("img", { className: "".concat(prefixCls, "-incall-rtc-user-avatar"), src: member.avatar || avatarDefaultMan }),
                        member.state !== 2 && React.createElement(Loading, null)),
                    React.createElement("div", { className: "".concat(prefixCls, "-incall-rtc-user-name") }, member.nick || member.tel))); })));
            }))),
        React.createElement("div", { className: "".concat(prefixCls, "-in-call-btn-group") },
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-microphone-btn"), src: enableLocalAudio ? microphoneOpen : microphoneClose, onClick: function () { return handleEnableLocalAudio(); } }),
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-video-btn"), src: enableLocalVideo ? videoOpen : videoClose, onClick: function () { return handleEnableLocalVideo(); } }),
            React.createElement("img", { draggable: "false", className: "".concat(prefixCls, "-hangup-btn"), onClick: function () { return handleHangup(); }, src: hangup }))));
};
var GroupCallViewProvider = forwardRef(function (props, ref) {
    var prefixCls = 'necall-group';
    var neGroupCallConfig = props.neGroupCallConfig, _a = props.position, position = _a === void 0 ? { x: 100, y: 100 } : _a, onInviteClick = props.onInviteClick;
    var draggableNodeRef = useRef(null);
    var _b = __read(useState(), 2), neGroupCall = _b[0], setNeGroupCall = _b[1];
    var _c = __read(useState(0), 2), callStatus = _c[0], setCallStatus = _c[1];
    var _d = __read(useState([]), 2), members = _d[0], setMembers = _d[1];
    var _e = __read(useState(), 2), callerAccid = _e[0], setCallerAccid = _e[1];
    useEffect(function () {
        if (neGroupCallConfig) {
            var neGroupCall_1 = NEGroupCall.getInstance();
            neGroupCall_1.setup(neGroupCallConfig);
            setNeGroupCall(neGroupCall_1);
            setCallStatus(0);
            return function () {
                neGroupCall_1 === null || neGroupCall_1 === void 0 ? void 0 : neGroupCall_1.destroy();
            };
        }
        // 这里需要在第一次挂载时才执行
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var getUserByNimAccount = useCallback(function (account) {
        return neGroupCallConfig.nim.V2NIMUserService.getUserList([
            account,
        ]).then(function (res) {
            var user = res[0];
            return {
                avatar: user === null || user === void 0 ? void 0 : user.avatar,
                nick: user === null || user === void 0 ? void 0 : user.name,
                tel: user === null || user === void 0 ? void 0 : user.mobile,
                account: user === null || user === void 0 ? void 0 : user.accountId,
            };
        });
    }, [neGroupCallConfig]);
    var updateMembers = useCallback(function (value) { return __awaiter(void 0, void 0, void 0, function () {
        var _members, _loop_1, value_1, value_1_1, member, e_1_1;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _members = [];
                    _loop_1 = function (member) {
                        var _member, res;
                        return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    _member = members.find(function (item) { return item.account === member.imAccid; });
                                    if (!_member) return [3 /*break*/, 1];
                                    _member.state = member.state;
                                    _members.push(_member);
                                    return [3 /*break*/, 3];
                                case 1: return [4 /*yield*/, getUserByNimAccount(member.imAccid)];
                                case 2:
                                    res = _c.sent();
                                    res.state = member.state;
                                    _members.push(res);
                                    _c.label = 3;
                                case 3: return [2 /*return*/];
                            }
                        });
                    };
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, 7, 8]);
                    value_1 = __values(value), value_1_1 = value_1.next();
                    _b.label = 2;
                case 2:
                    if (!!value_1_1.done) return [3 /*break*/, 5];
                    member = value_1_1.value;
                    return [5 /*yield**/, _loop_1(member)];
                case 3:
                    _b.sent();
                    _b.label = 4;
                case 4:
                    value_1_1 = value_1.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (value_1_1 && !value_1_1.done && (_a = value_1.return)) _a.call(value_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 8:
                    setMembers(_members);
                    return [2 /*return*/];
            }
        });
    }); }, [members, getUserByNimAccount]);
    useEffect(function () {
        function handleReceiveInvited(value) {
            setCallerAccid(value.callerAccid);
            updateMembers(value.members).then(function () {
                setCallStatus(1);
            });
        }
        function handleMembersChange(value) {
            // 通话中，更新成员列表
            callStatus === 2 && updateMembers(value);
        }
        function handleCallEnd() {
            setCallStatus(0);
        }
        neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.on('onReceiveInvited', handleReceiveInvited);
        neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.on('onMembersChange', handleMembersChange);
        neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.on('onCallEnd', handleCallEnd);
        return function () {
            neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.off('onReceiveInvited', handleReceiveInvited);
            neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.off('onMembersChange', handleMembersChange);
            neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.off('onCallEnd', handleCallEnd);
        };
    }, [
        neGroupCall,
        getUserByNimAccount,
        neGroupCallConfig,
        updateMembers,
        callStatus,
    ]);
    var handleCall = useCallback(function (opt) { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!neGroupCall) return [3 /*break*/, 3];
                    return [4 /*yield*/, neGroupCall.groupCall(opt)];
                case 1:
                    res = _a.sent();
                    return [4 /*yield*/, updateMembers(res.members)];
                case 2:
                    _a.sent();
                    setCallStatus(2);
                    return [2 /*return*/, res];
                case 3: return [2 /*return*/];
            }
        });
    }); }, [neGroupCall, updateMembers]);
    var handleJoin = useCallback(function (opt) { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!neGroupCall) return [3 /*break*/, 2];
                    return [4 /*yield*/, neGroupCall.groupJoin(opt)];
                case 1:
                    res = _a.sent();
                    setCallStatus(2);
                    return [2 /*return*/, res];
                case 2: return [2 /*return*/];
            }
        });
    }); }, [neGroupCall]);
    var handleAccept = function () {
        if (neGroupCall) {
            neGroupCall
                .groupAccept()
                .then(function (res) {
                return updateMembers(res.members);
            })
                .then(function () {
                setCallStatus(2);
            });
        }
    };
    var handleHangup = function () {
        if (neGroupCall) {
            neGroupCall.groupHangup();
            setCallStatus(0);
        }
    };
    useImperativeHandle(ref, function () { return ({
        onMsg: function (msg) {
            return neGroupCall === null || neGroupCall === void 0 ? void 0 : neGroupCall.receiveNimMsg(msg);
        },
        groupCall: handleCall,
        groupJoin: handleJoin,
        neGroupCall: neGroupCall,
    }); }, [neGroupCall, handleCall, handleJoin]);
    return (React.createElement(GroupCallProvider, { value: {
            groupCall: handleCall,
            groupJoin: handleJoin,
            neGroupCall: neGroupCall,
        } },
        callStatus !== 0 && neGroupCall && (React.createElement(Draggable, { nodeRef: draggableNodeRef, handle: ".".concat(prefixCls, "-drag-handle"), cancel: ".".concat(prefixCls, "-called-btn-group .").concat(prefixCls, "-img, .").concat(prefixCls, "-in-call-btn-group") },
            React.createElement("div", { style: { top: position.y, left: position.x }, className: "".concat(prefixCls, "-view"), ref: draggableNodeRef },
                React.createElement("div", { className: "".concat(prefixCls, "-drag-handle") }),
                onInviteClick && callStatus === 2 && (React.createElement(AddOutline, { className: "".concat(prefixCls, "-invite-btn"), onClick: onInviteClick })),
                callStatus === 1 && callerAccid && (React.createElement(InvitedView, { members: members, currentAccid: neGroupCallConfig.nim.account, callerAccid: callerAccid, onAccept: handleAccept, onReject: handleHangup })),
                callStatus === 2 && (React.createElement(InCallView, { neGroupCall: neGroupCall, members: members, onHangup: handleHangup }))))),
        props.children));
});
export default GroupCallViewProvider;
