import React from 'react';
import { NECall, NECallParam, NECallInfo, NESetupConfig } from '@xkit-yx/call-kit';
interface ICallContext {
    call?: (opt: NECallParam) => Promise<NECallInfo | undefined>;
    neCall?: NECall;
}
declare const useCall: () => ICallContext;
declare const CallProvider: React.Provider<ICallContext>;
export { CallProvider, useCall };
interface SwitchCallTypeBtn {
    switchToVideo?: boolean;
    switchToAudio?: boolean;
}
interface CallViewProps {
    neCallConfig: NESetupConfig;
    uiConfig?: {
        switchCallTypeBtn?: SwitchCallTypeBtn;
    };
    position?: {
        x: number;
        y: number;
    };
}
export interface CallViewProviderRef {
    call: (opt: NECallParam) => Promise<NECallInfo | undefined>;
    neCall?: NECall;
}
declare const CallViewProvider: React.ForwardRefExoticComponent<CallViewProps & {
    children?: React.ReactNode;
} & React.RefAttributes<CallViewProviderRef>>;
export default CallViewProvider;
