import React from 'react';
import { NEGroupCall, NEGroupCallCallFnParams, NEGroupCallConfig, NEGroupCallCallRes } from '@xkit-yx/call-kit';
interface IGroupCallContext {
    neGroupCall?: NEGroupCall;
    groupCall?: (opt: NEGroupCallCallFnParams) => Promise<NEGroupCallCallRes | undefined>;
    groupJoin?: (opt: {
        callId: string;
        rtcUid?: number;
    }) => Promise<NEGroupCallCallRes | undefined>;
}
declare const useGroupCall: () => IGroupCallContext;
declare const GroupCallProvider: React.Provider<IGroupCallContext>;
export { GroupCallProvider, useGroupCall };
interface GroupCallViewProviderProps {
    neGroupCallConfig: NEGroupCallConfig;
    position?: {
        x: number;
        y: number;
    };
    onInviteClick?: (event: React.MouseEvent<SVGSVGElement, MouseEvent>) => void;
}
export interface GroupCallViewProviderRef {
    onMsg: (msg: string) => void;
}
declare const GroupCallViewProvider: React.ForwardRefExoticComponent<GroupCallViewProviderProps & {
    children?: React.ReactNode;
} & React.RefAttributes<GroupCallViewProviderRef>>;
export default GroupCallViewProvider;
